gtksourceviewmm: Gsv::Completion Class Reference

gtksourceviewmm 3.2.0

- Main Page
- Related Pages
- Modules
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions
Gsv::Completion Class Reference

Main Completion Object. More...

`#include <gtksourceviewmm/completion.h>`

Inheritance diagram for Gsv::Completion:
[legend]

List of all members.

## Public Member Functions
GtkSourceCompletion* | gobj ()
| Provides access to the underlying C GObject.
const GtkSourceCompletion* | gobj () const
| Provides access to the underlying C GObject.
GtkSourceCompletion* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | add_provider (const Glib::RefPtr< CompletionProvider >& provider)
| Add a new CompletionProvider to the completion object.
bool | remove_provider (const Glib::RefPtr< CompletionProvider >& provider)
| Remove provider from the completion.
std::vector< Glib::RefPtr < CompletionProvider > > | get_providers () const
| Get list of providers registered on completion.
bool | show (const std::vector< Glib::RefPtr< CompletionProvider > >& providers, const Glib::RefPtr< CompletionContext >& context)
| Starts a new completion with the specified CompletionContext and a list of potential candidate providers for completion.
void | hide ()
| Hides the completion if it is active (visible).
CompletionInfo* | get_info_window ()
| Gets the CompletionInfo window.
const CompletionInfo* | get_info_window () const
| Gets the CompletionInfo window.
View* | get_view ()
| Gets the View associated with completion.
const View* | get_view () const
| Gets the View associated with completion.
Glib::RefPtr< CompletionContext > | create_context (const Gtk::TextIter& position)
| Create a new CompletionContext for completion.
Glib::RefPtr< CompletionContext > | create_context ()
| Create a new CompletionContext for completion.
void | move_window (const Gtk::TextIter& iter)
| Move the completion window to a specific iter.
void | block_interactive ()
| Block interactive completion.
void | unblock_interactive ()
| Unblock interactive completion.
Glib::SignalProxy0< void > | signal_hide ()
| Emitted when the completion window is hidden.
Glib::SignalProxy1< void, const Glib::RefPtr < CompletionContext >& > | signal_populate_context ()
| Emitted just before starting to populate the completion with providers.
Glib::SignalProxy0< void > | signal_show ()
| Emitted when the completion window is shown.
Glib::PropertyProxy< guint > | property_accelerators ()
| Number of proposal accelerators to show.
Glib::PropertyProxy_ReadOnly < guint > | property_accelerators () const
| Number of proposal accelerators to show.
Glib::PropertyProxy< guint > | property_auto_complete_delay ()
| Completion popup delay for interactive completion.
Glib::PropertyProxy_ReadOnly < guint > | property_auto_complete_delay () const
| Completion popup delay for interactive completion.
Glib::PropertyProxy< guint > | property_proposal_page_size ()
| Proposal scrolling page size.
Glib::PropertyProxy_ReadOnly < guint > | property_proposal_page_size () const
| Proposal scrolling page size.
Glib::PropertyProxy< guint > | property_provider_page_size ()
| Provider scrolling page size.
Glib::PropertyProxy_ReadOnly < guint > | property_provider_page_size () const
| Provider scrolling page size.
Glib::PropertyProxy< bool > | property_remember_info_visibility ()
| Remember the last info window visibility state.
Glib::PropertyProxy_ReadOnly < bool > | property_remember_info_visibility () const
| Remember the last info window visibility state.
Glib::PropertyProxy< bool > | property_select_on_show ()
| Select first proposal when completion is shown.
Glib::PropertyProxy_ReadOnly < bool > | property_select_on_show () const
| Select first proposal when completion is shown.
Glib::PropertyProxy< bool > | property_show_headers ()
| Show provider headers when proposals from multiple providers are available.
Glib::PropertyProxy_ReadOnly < bool > | property_show_headers () const
| Show provider headers when proposals from multiple providers are available.
Glib::PropertyProxy< bool > | property_show_icons ()
| Show provider and proposal icons in the completion popup.
Glib::PropertyProxy_ReadOnly < bool > | property_show_icons () const
| Show provider and proposal icons in the completion popup.
Glib::PropertyProxy_ReadOnly < View* > | property_view () const
| The GtkSourceView bound to the completion.
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gsv::Completion > | wrap (GtkSourceCompletion* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Main Completion Object.

Since gtksourceviewmm 2.10:

## Member Function Documentation

bool Gsv::Completion::add_provider | ( | const Glib::RefPtr< CompletionProvider >& | provider | ) |

Add a new CompletionProvider to the completion object.

This will add a reference provider.

Parameters:

  provider | A CompletionProvider.

Returns:
  `true` if provider was successfully added, otherwise error is thrown.

Since gtksourceviewmm 2.10:

void Gsv::Completion::block_interactive | ( |  | ) |

Block interactive completion.

This can be used to disable interactive completion when inserting or deleting text from the buffer associated with the completion. Use unblock_interactive() to enable interactive completion again.

Since gtksourceviewmm 2.10:

Glib::RefPtr<CompletionContext> Gsv::Completion::create_context | ( | const Gtk::TextIter & | position | ) |

Create a new CompletionContext for completion.

The position at which the completion using the new context will consider completion can be provided by position.

Parameters:

  position | A Gtk::TextIter.

Returns:
  A new CompletionContext.

Since gtksourceviewmm 2.10:

Glib::RefPtr<CompletionContext> Gsv::Completion::create_context | ( |  | ) |

Create a new CompletionContext for completion.

The position at which the completion using the new context will consider completion is current cursor position.

Returns:
  A new CompletionContext.

Since gtksourceviewmm 2.10:

CompletionInfo* Gsv::Completion::get_info_window | ( |  | ) |

Gets the CompletionInfo window.

The info widget is the window where the completion displays optional extra information of the proposal.

Returns:
  The CompletionInfo window.

Since gtksourceviewmm 2.10:

const CompletionInfo* Gsv::Completion::get_info_window | ( |  | ) | const

Gets the CompletionInfo window.

The info widget is the window where the completion displays optional extra information of the proposal.

Returns:
  The CompletionInfo window.

Since gtksourceviewmm 2.10:

std::vector<Glib::RefPtr<CompletionProvider> > Gsv::Completion::get_providers | ( |  | ) | const

Get list of providers registered on completion.

Returns:
  List of CompletionProvider.

Since gtksourceviewmm 2.10:

View* Gsv::Completion::get_view | ( |  | ) |

Gets the View associated with completion.

Returns:
  The View associated with completion.

Since gtksourceviewmm 2.10:

const View* Gsv::Completion::get_view | ( |  | ) | const

Gets the View associated with completion.

Returns:
  The View associated with completion.

Since gtksourceviewmm 2.10:

void Gsv::Completion::hide | ( |  | ) |

Hides the completion if it is active (visible).

Since gtksourceviewmm 2.10:

void Gsv::Completion::move_window | ( | const Gtk::TextIter & | iter | ) |

Move the completion window to a specific iter.

Parameters:

  iter | A Gtk::TextIter.

Since gtksourceviewmm 2.10:

Glib::PropertyProxy<guint> Gsv::Completion::property_accelerators | ( |  | ) |

Number of proposal accelerators to show.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<guint> Gsv::Completion::property_accelerators | ( |  | ) | const

Number of proposal accelerators to show.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<guint> Gsv::Completion::property_auto_complete_delay | ( |  | ) |

Completion popup delay for interactive completion.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<guint> Gsv::Completion::property_auto_complete_delay | ( |  | ) | const

Completion popup delay for interactive completion.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<guint> Gsv::Completion::property_proposal_page_size | ( |  | ) |

Proposal scrolling page size.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<guint> Gsv::Completion::property_proposal_page_size | ( |  | ) | const

Proposal scrolling page size.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<guint> Gsv::Completion::property_provider_page_size | ( |  | ) |

Provider scrolling page size.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<guint> Gsv::Completion::property_provider_page_size | ( |  | ) | const

Provider scrolling page size.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gsv::Completion::property_remember_info_visibility | ( |  | ) |

Remember the last info window visibility state.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gsv::Completion::property_remember_info_visibility | ( |  | ) | const

Remember the last info window visibility state.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gsv::Completion::property_select_on_show | ( |  | ) | const

Select first proposal when completion is shown.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gsv::Completion::property_select_on_show | ( |  | ) |

Select first proposal when completion is shown.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gsv::Completion::property_show_headers | ( |  | ) | const

Show provider headers when proposals from multiple providers are available.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gsv::Completion::property_show_headers | ( |  | ) |

Show provider headers when proposals from multiple providers are available.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gsv::Completion::property_show_icons | ( |  | ) |

Show provider and proposal icons in the completion popup.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gsv::Completion::property_show_icons | ( |  | ) | const

Show provider and proposal icons in the completion popup.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<View*> Gsv::Completion::property_view | ( |  | ) | const

The GtkSourceView bound to the completion.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

bool Gsv::Completion::remove_provider | ( | const Glib::RefPtr< CompletionProvider >& | provider | ) |

Remove provider from the completion.

Parameters:

  provider | A CompletionProvider.

Returns:
  `true` if provider was successfully removed, otherwise error is thrown.

Since gtksourceviewmm 2.10:

bool Gsv::Completion::show | ( | const std::vector< Glib::RefPtr< CompletionProvider > >& | providers,
|  | const Glib::RefPtr< CompletionContext >& | context
| ) |  |

Starts a new completion with the specified CompletionContext and a list of potential candidate providers for completion.

Parameters:

  providers | A list of CompletionProvider.
  context | The CompletionContext with which to start the completion.

Returns:
  `true` if it was possible to the show completion window.

Since gtksourceviewmm 2.10:

Glib::SignalProxy0< void > Gsv::Completion::signal_hide | ( |  | ) |

Emitted when the completion window is hidden.

The default handler will actually hide the window.

Since gtksourceviewmm 2.10:

Prototype:
  `void on_my_hide()`

Glib::SignalProxy1< void,const Glib::RefPtr<CompletionContext>& > Gsv::Completion::signal_populate_context | ( |  | ) |

Emitted just before starting to populate the completion with providers.

You can use this signal to add additional attributes in the context.

Handler parameters:
  context The context for current completion.

Since gtksourceviewmm 2.10:

Prototype:
  `void on_my_populate_context(const Glib::RefPtr<CompletionContext>& context)`

Glib::SignalProxy0< void > Gsv::Completion::signal_show | ( |  | ) |

Emitted when the completion window is shown.

The default handler will actually show the window.

Since gtksourceviewmm 2.10:

Prototype:
  `void on_my_show()`

void Gsv::Completion::unblock_interactive | ( |  | ) |

Unblock interactive completion.

This can be used after using block_interactive() to enable interactive completion again.

Since gtksourceviewmm 2.10:

## Friends And Related Function Documentation

Glib::RefPtr< Gsv::Completion > wrap | ( | GtkSourceCompletion * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.